--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--								University of Hawaii at Manoa						         --
--						Instrumentation Development Lab / GARY S. VARNER				--
--   								Watanabe Hall Room 214								      --
--  								  2505 Correa Road										   --
--  								 Honolulu, HI 96822											--
--  								Lab: (808) 956-2920											--
--	 								Fax: (808) 956-2930										   --
--  						E-mail: idlab@phys.hawaii.edu									   --
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------	
-- Design by: Larry L. Ruckman Jr.															--
-- DATE : 22 OCT 2007																			--
-- Project name: ROBUSTv3 firmware															--
--	Module name: BLAB1_PIXx32	  																--
--	Description : 																					--
-- 	32 stored cell block																		--
--		  											    												--
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity SCALER is
   port ( 
			 xCLR_CNT	 	: in   std_logic;
			 xCOUNT 			: in   std_logic;
			 xOUT				: out   std_logic_vector (15 downto 0));
end SCALER;

architecture Behavioral of SCALER is
	signal CNT				: std_logic_vector (15 downto 0);	
--------------------------------------------------------------------------------
--   								components     		   						         --
--------------------------------------------------------------------------------
	component BUF16
    Port ( 
			  I   : in   std_logic_vector (15 downto 0);
			  O	: out  std_logic_vector (15 downto 0));
   end component;
--------------------------------------------------------------------------------	
begin
--------------------------------------------------------------------------------			
	process(xCLR_CNT,xCOUNT)
	begin
		if xCLR_CNT = '1' then
			CNT <= (others=>'0');
		elsif rising_edge(xCOUNT) then
			if CNT < 60000 then
				CNT <= CNT + 1;
			end if;
		end if;
	end process;
--------------------------------------------------------------------------------			
	xBUF_OUT : BUF16 
	port map (
		I(15 downto 0)=> CNT(15 downto 0),
		O(15 downto 0)=> xOUT(15 downto 0));
--------------------------------------------------------------------------------							
end Behavioral;