--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--								University of Hawaii at Manoa						         --
--						Instrumentation Development Lab / GARY S. VARNER				--
--   								Watanabe Hall Room 214								      --
--  								  2505 Correa Road										   --
--  								 Honolulu, HI 96822											--
--  								Lab: (808) 956-2920											--
--	 								Fax: (808) 956-2930										   --
--  						E-mail: idlab@phys.hawaii.edu									   --
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------	
-- Design by: Larry L. Ruckman Jr.															--
-- DATE : 22 OCT 2007																			--
-- Project name: ROBUSTv3 firmware															--
--	Module name: BLAB1_PIXx32	  																--
--	Description : 																					--
-- 	32 stored cell block																		--
--		  											    												--
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity TARGET_PIXx16 is
port ( 
			 xRAMP			: in    std_logic;
			 xREF    		: in    std_logic_vector (11 downto 0);
			 xDAT				: in    std_logic_vector (15 downto 0);
			 xGCC1			: in    std_logic_vector (11 downto 0);
			 xGCC2			: in    std_logic_vector (11 downto 0);
			 xADDR			: in    std_logic_vector (3 downto 0);
			 xOUT				: out   std_logic_vector (15 downto 0));
end TARGET_PIXx16;

architecture Behavioral of TARGET_PIXx16 is
	signal HIT0		: std_logic_vector(15 downto 0);
	signal HIT1		: std_logic_vector(15 downto 0);
	signal HIT2		: std_logic_vector(15 downto 0);
	signal HIT3		: std_logic_vector(15 downto 0);	
	signal HIT4		: std_logic_vector(15 downto 0);
	signal HIT5		: std_logic_vector(15 downto 0);
	signal HIT6		: std_logic_vector(15 downto 0);
	signal HIT7		: std_logic_vector(15 downto 0);	
	signal HIT8		: std_logic_vector(15 downto 0);
	signal HIT9		: std_logic_vector(15 downto 0);
	signal HIT10	: std_logic_vector(15 downto 0);
	signal HIT11	: std_logic_vector(15 downto 0);	
	signal HIT12	: std_logic_vector(15 downto 0);
	signal HIT13	: std_logic_vector(15 downto 0);
	signal HIT14	: std_logic_vector(15 downto 0);
	signal HIT15	: std_logic_vector(15 downto 0);	
	signal OUTPUT	: std_logic_vector(15 downto 0);	
--------------------------------------------------------------------------------
--   								components     		   						         --
--------------------------------------------------------------------------------	
   component GCCx2v2
	port ( 
			 xRAMP			: in    std_logic;
			 xLOCK			: in    std_logic;
			 xREF				: in	  std_logic_vector(11 downto 0);
			 xGCC1			: in	  std_logic_vector(11 downto 0);
			 xGCC2			: in	  std_logic_vector(11 downto 0);
			 xOUT				: out   std_logic_vector(15 downto 0));
   end component;
--------------------------------------------------------------------------------	
	component BUF16
    Port ( 
			  I   : in   std_logic_vector (15 downto 0);
			  O	: out  std_logic_vector (15 downto 0));
   end component;
--------------------------------------------------------------------------------	
begin
--------------------------------------------------------------------------------	
	xGCCx2_0 : GCCx2v2 
	port map (
		xREF 		=> xREF,
		xGCC1 	=> xGCC1,
		xGCC2 	=> xGCC2,
		xRAMP 	=> xRAMP,
		xLOCK 	=> xDAT(0),
		xOUT 		=> HIT0);
--------------------------------------------------------------------------------	
	xGCCx2_1 : GCCx2v2 
	port map (
		xREF 		=> xREF,
		xGCC1		=> xGCC1,
		xGCC2 	=> xGCC2,
		xRAMP 	=> xRAMP,
		xLOCK 	=> xDAT(1),
		xOUT 		=> HIT1);
--------------------------------------------------------------------------------	
	xGCCx2_2 : GCCx2v2 
	port map (
		xREF 		=> xREF,
		xGCC1 	=> xGCC1,
		xGCC2 	=> xGCC2,
		xRAMP 	=> xRAMP,
		xLOCK 	=> xDAT(2),
		xOUT 		=> HIT2);
--------------------------------------------------------------------------------	
	xGCCx2_3 : GCCx2v2 
	port map (
		xREF 		=> xREF,
		xGCC1 	=> xGCC1,
		xGCC2 	=> xGCC2,
		xRAMP 	=> xRAMP,
		xLOCK 	=> xDAT(3),
		xOUT 		=> HIT3);
--------------------------------------------------------------------------------	
	xGCCx2_4 : GCCx2v2 
	port map (
		xREF 		=> xREF,
		xGCC1 	=> xGCC1,
		xGCC2 	=> xGCC2,
		xRAMP 	=> xRAMP,
		xLOCK 	=> xDAT(4),
		xOUT 		=> HIT4);
--------------------------------------------------------------------------------	
	xGCCx2_5 : GCCx2v2 
	port map (
		xREF 		=> xREF,
		xGCC1 	=> xGCC1,
		xGCC2 	=> xGCC2,
		xRAMP 	=> xRAMP,
		xLOCK 	=> xDAT(5),
		xOUT 		=> HIT5);
--------------------------------------------------------------------------------	
	xGCCx2_6 : GCCx2v2 
	port map (
		xREF 		=> xREF,
		xGCC1 	=> xGCC1,
		xGCC2 	=> xGCC2,
		xRAMP 	=> xRAMP,
		xLOCK 	=> xDAT(6),
		xOUT 		=> HIT6);
--------------------------------------------------------------------------------	
	xGCCx2_7 : GCCx2v2 
	port map (
		xREF 		=> xREF,
		xGCC1 	=> xGCC1,
		xGCC2 	=> xGCC2,
		xRAMP 	=> xRAMP,
		xLOCK 	=> xDAT(7),
		xOUT 		=> HIT7);
--------------------------------------------------------------------------------	
	xGCCx2_8 : GCCx2v2 
	port map (
		xREF 		=> xREF,
		xGCC1 	=> xGCC1,
		xGCC2 	=> xGCC2,
		xRAMP 	=> xRAMP,
		xLOCK 	=> xDAT(8),
		xOUT 		=> HIT8);
--------------------------------------------------------------------------------	
	xGCCx2_9 : GCCx2v2 
	port map (
		xREF 		=> xREF,
		xGCC1 	=> xGCC1,
		xGCC2 	=> xGCC2,
		xRAMP 	=> xRAMP,
		xLOCK 	=> xDAT(9),
		xOUT 		=> HIT9);
--------------------------------------------------------------------------------	
	xGCCx2_10 : GCCx2v2 
	port map (
		xREF 		=> xREF,
		xGCC1 	=> xGCC1,
		xGCC2 	=> xGCC2,
		xRAMP 	=> xRAMP,
		xLOCK 	=> xDAT(10),
		xOUT 		=> HIT10);
--------------------------------------------------------------------------------	
	xGCCx2_11 : GCCx2v2 
	port map (
		xREF 		=> xREF,
		xGCC1 	=> xGCC1,
		xGCC2 	=> xGCC2,
		xRAMP 	=> xRAMP,
		xLOCK 	=> xDAT(11),
		xOUT 		=> HIT11);
--------------------------------------------------------------------------------	
	xGCCx2_12 : GCCx2v2 
	port map (
		xREF 		=> xREF,
		xGCC1 	=> xGCC1,
		xGCC2 	=> xGCC2,
		xRAMP 	=> xRAMP,
		xLOCK 	=> xDAT(12),
		xOUT 		=> HIT12);
--------------------------------------------------------------------------------	
	xGCCx2_13 : GCCx2v2 
	port map (
		xREF 		=> xREF,
		xGCC1 	=> xGCC1,
		xGCC2 	=> xGCC2,
		xRAMP 	=> xRAMP,
		xLOCK 	=> xDAT(13),
		xOUT 		=> HIT13);
--------------------------------------------------------------------------------	
	xGCCx2_14 : GCCx2v2 
	port map (
		xREF 		=> xREF,
		xGCC1		=> xGCC1,
		xGCC2 	=> xGCC2,
		xRAMP 	=> xRAMP,
		xLOCK 	=> xDAT(14),
		xOUT 		=> HIT14);
--------------------------------------------------------------------------------	
	xGCCx2_15 : GCCx2v2 
	port map (
		xREF 		=> xREF,
		xGCC1 	=> xGCC1,
		xGCC2 	=> xGCC2,
		xRAMP 	=> xRAMP,
		xLOCK 	=> xDAT(15),
		xOUT 		=> HIT15);
--------------------------------------------------------------------------------
	process(xADDR)
	begin
		if xADDR = 0 then
			OUTPUT <= HIT0;
		elsif xADDR = 1 then
			OUTPUT <= HIT1;
		elsif xADDR = 2 then
			OUTPUT <= HIT2;
		elsif xADDR = 3 then
			OUTPUT <= HIT3;
		elsif xADDR = 4 then
			OUTPUT <= HIT4;
		elsif xADDR = 5 then
			OUTPUT <= HIT5;
		elsif xADDR = 6 then
			OUTPUT <= HIT6;
		elsif xADDR = 7 then
			OUTPUT <= HIT7;
		elsif xADDR = 8 then
			OUTPUT <= HIT8;
		elsif xADDR = 9 then
			OUTPUT <= HIT9;
		elsif xADDR = 10 then
			OUTPUT <= HIT10;
		elsif xADDR = 11 then
			OUTPUT <= HIT11;
		elsif xADDR = 12 then
			OUTPUT <= HIT12;
		elsif xADDR = 13 then
			OUTPUT <= HIT13;
		elsif xADDR = 14 then
			OUTPUT <= HIT14;
		elsif xADDR = 15 then
			OUTPUT <= HIT15;
		end if;
	end process;
--------------------------------------------------------------------------------	
	xBUF_OUTPUT : BUF16 
	port map (
		I(15 downto 0)=> OUTPUT(15 downto 0),
		O(15 downto 0)=> xOUT(15 downto 0));	
--------------------------------------------------------------------------------	
end Behavioral;