--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--								University of Hawaii at Manoa						         --
--						Instrumentation Development Lab / GARY S. VARNER				--
--   								Watanabe Hall Room 214								      --
--  								  2505 Correa Road										   --
--  								 Honolulu, HI 96822											--
--  								Lab: (808) 956-2920											--
--	 								Fax: (808) 956-2930										   --
--  						E-mail: idlab@phys.hawaii.edu									   --
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------	
-- Design by: Larry L. Ruckman Jr.															--
-- DATE : 23 JUNE 2007																			--
-- Project name: ICRR firmware																--
--	Module name: OBUF3				  																--
--	Description : 																					--
-- 	Output Buffer 3 bits wide																--
--		  											    												--
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity OBUF3 is
   port ( 
          I  	: in    std_logic_vector (2 downto 0);
          O		: out   std_logic_vector (2 downto 0));
end OBUF3;

architecture Behavioral of OBUF3 is
--------------------------------------------------------------------------------
--   								components     		   						         --
--------------------------------------------------------------------------------
   component OBUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
--------------------------------------------------------------------------------
begin
--------------------------------------------------------------------------------		
	xBUF_0 : OBUF 
	port map (
		I  => I(0),
		O  => O(0));
--------------------------------------------------------------------------------		
	xBUF_1 : OBUF 
	port map (
		I  => I(1),
		O  => O(1));
--------------------------------------------------------------------------------		
	xBUF_2 : OBUF 
	port map (
		I  => I(2),
		O  => O(2));
--------------------------------------------------------------------------------		
end Behavioral;